<script lang="ts">
export default {
  name: 'SurveyBubbleChart',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      isNotEnglish: null,
    };
  },
  computed: {
    tableGridStyle() {
      const columnsCount = this.data.columns ? this.data.columns.length : 1;
      return {
        'grid-template-columns': `${columnsCount > 1 ? '150px' : '60%'} repeat(${columnsCount}, 1fr)`,
      };
    },
  },
  created() {
    const locale = this.$i18n.locale;

    if (locale.includes('de-de') || locale.includes('fr-fr')) {
      this.isNotEnglish = true;
    }
  },
  mounted() {
    const observer = new IntersectionObserver(
      (entries) => {
        entries.forEach((entry) => {
          if (entry.isIntersecting) {
            entry.target.classList.add('bubble-visible');
          }
        });
      },
      {
        threshold: 0.1,
      },
    );
    this.$nextTick(() => {
      const bubbles = this.$el.querySelectorAll('.bubble, .whole-bubble');
      bubbles.forEach((bubble) => observer.observe(bubble));
    });
  },
  methods: {
    convertToSnakeCase(text) {
      return text
        .toLowerCase()
        .replace(/[\u{1F1E6}-\u{1F1FF}]\s?/gu, '') // Removes flag emojis and the space after them
        .replace(/[\u{1F30D}-\u{1F30F}]\s?/gu, '') // Removes globe/world emojis and the space after them
        .replace(/[’!@#$%^&*()_+={}:;"'<>,.?|~`[\]]/g, '') // Removes special characters
        .replace(/[-/]/g, '_') // Replaces hyphens and slashes with underscores
        .replace(/\s+/g, '_'); // Replaces spaces with underscores
    },
    bubbleStyle(value, color) {
      if (value == 0) {
        return {
          width: '0px',
          height: '0px',
          lineHeight: '0px',
        };
      } else {
        const size = value * 2;
        return {
          width: `${size}px`,
          height: `${size}px`,
          lineHeight: `${size}px`,
          backgroundColor: color,
        };
      }
    },
  },
};
</script>

<template>
  <div>
    <SlpTypography variant="heading5-bold" tag="p" class="slp-my-24">
      {{ data.header }}
    </SlpTypography>
    <div class="table-container" :style="tableGridStyle">
      <!-- Columns -->
      <div v-if="data.columns" class="header-row">
        <div class="header-cell"></div>
        <div
          v-for="column in data.columns"
          :key="column.label"
          class="header-cell"
        >
          {{ column.label }}
        </div>
      </div>

      <!-- Rows -->
      <div v-for="row in data.rows" :key="row" class="data-row">
        <div class="row-header">
          {{ row }}
        </div>
        <template v-if="data.columns">
          <div v-for="column in data.columns" :key="column.label" class="cell">
            <div
              class="bubble"
              :style="
                bubbleStyle(
                  data.data[convertToSnakeCase(row)][
                    convertToSnakeCase(column.label)
                  ],
                  column.color,
                )
              "
              :aria-label="
                row +
                ' ' +
                column.label +
                ' ' +
                data.data[convertToSnakeCase(row)][
                  convertToSnakeCase(column.label)
                ] +
                '%'
              "
            >
              {{
                data.data[convertToSnakeCase(row)][
                  convertToSnakeCase(column.label)
                ]
              }}%
            </div>
          </div>
        </template>

        <template v-else-if="!data.columns && !data.whole_numbers">
          <div class="cell single">
            <div
              class="bubble"
              :style="
                bubbleStyle(
                  data.data[convertToSnakeCase(row)].percentage
                    ? data.data[convertToSnakeCase(row)].percentage
                    : data.data[convertToSnakeCase(row)],
                  data.color,
                )
              "
              :aria-label="row + ' ' + data.data[convertToSnakeCase(row)] + '%'"
            >
              {{ data.data[convertToSnakeCase(row)] }}%
            </div>
          </div>
        </template>
        <template v-else-if="!data.columns && data.whole_numbers">
          <div class="cell">
            <div
              class="whole-bubble"
              :style="
                bubbleStyle(
                  data.data[convertToSnakeCase(row)].percentage
                    ? data.data[convertToSnakeCase(row)].percentage
                    : data.data[convertToSnakeCase(row)],
                  data.color,
                )
              "
            >
              <span v-if="data.data[convertToSnakeCase(row)].tag">
                {{ data.data[convertToSnakeCase(row)].tag }}
              </span>
              <span v-else>
                {{
                  data.data[convertToSnakeCase(row)].percentage ||
                  data.data[convertToSnakeCase(row)]
                }}
              </span>
            </div>
          </div>
        </template>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.table-container {
  display: grid;
  grid-auto-rows: minmax(min-content, max-content);
  align-items: stretch;
  hyphens: auto;
}
.header-row,
.data-row {
  display: contents;
}

.data-row .row-header {
  display: flex;
  align-items: center;
  text-align: left;
}

.header-row .header-cell {
  margin: auto 0;
}

.row-header,
.cell {
  border-top: 1px dashed #232150;
  margin: 0 1px;

  &.single {
  }
}

.header-cell {
  padding-bottom: 16px;
}

.header-cell,
.row-header {
  font-weight: bold;
  text-align: center;
}
.cell {
  display: flex;
  align-items: center;
  justify-content: center;
  min-height: 100px;
  font-weight: $font-weight-bold;
  padding: 24px 0;

  @media (max-width: $breakpoint-md) {
    padding: 24px;
  }
}
.bubble,
.whole-bubble {
  display: flex;
  align-items: center;
  justify-content: center;
  border-radius: 50%;
  color: #232150;
  font-family: 'GitLab Mono';
  text-align: center;
  font-size: 24px;
  transform: scale(0);
  transition: transform 0.8s ease-out;

  @media (prefers-reduced-motion: reduce) {
    transition: none;
  }
}

.bubble-visible {
  transform: scale(1);
}

.bubble {
  background-color: #10b1b1;
}
</style>
